


#define Vcc 1.1       // Tension d'alimentation

float u;            // Tension aux bornes du capteur
float T;            // Température en °C


void setup() {
  Serial.begin(9600);  // Paramétrage du port série
  analogReference(INTERNAL);

}

void loop() {
  u = analogRead(A0) * Vcc / 1024; // Lecture tension en V
  T = u * 100;         // Calcul de la température en °C
  // Début affichage

  Serial.print("T = ");
  Serial.println(T);                // Fin affichage
  delay(1000);                     // Temporisation de 1s
}
