// La lecture d'entrée se fait sur A1 et la commande PWM sur D3
// utilisation d'un ampli fois 2 dans le montage ainsi qu'un filtre RC anti-repliement
// Il y a ajout d'un filtre numérique ici

// la mesure se fait touts les 10ms
//l'affichage se fait sur l'écran LCD toutes les 0,1 s
// l'affichage sur le moniyeur série toutes les secondes.


#include <Wire.h>;
#include <LiquidCrystal_I2C.h>;

unsigned long millis();
int k=0;
int s=0;
unsigned long ecart;
unsigned long lastTime;
float temps=0;


float ki=0.01;
float kd=90;
double commande;
double consigne;
int N=255;
int Gain=70;


double temperature,tension,erreur,Somme_erreurs,Delta_erreur ;
double erreur_precedente=0;
int entree,entreeprec;


float mesure=0.00;
int temp;
LiquidCrystal_I2C lcd(0x27, 16, 2);


// Boucle Setup pour indiquer le port de communication
void setup()   {
  Serial.begin(9600);
  commande=255;
  consigne=30,
  lcd.init(); // initialisation de l'afficheur
 analogReference(INTERNAL);
  pinMode(3,OUTPUT);
 
 Serial.print("Temps(s) ");Serial.print(";");Serial.print("Température (°C)"); Serial.println("N (pwm)");
 lcd.backlight();
 lcd.setCursor(0, 0);
 lcd.print("Consigne :");
 lcd.setCursor(0,1);
 lcd.print("Temp :");


lastTime=millis();
}

// Boucle principale
void loop()
{ 

ecart=millis()-lastTime;
  if(ecart>10){     lastTime=millis();
                    k=k+1;
                    entree=analogRead(A1);
                    mesure= 0.88836479*mesure+0.11163521*entree;
                    
                    tension=1.1*mesure/1024.0;
                    temperature=tension*100/2;
                    
                  
                  if (k==10){
                   
                             lcd.setCursor(11, 0);
                             lcd.print(consigne,2);
                             lcd.setCursor(11,1);
                             lcd.print(temperature,2);
                             s=s+1;
                             k=0;}
                            
                   if (s==10) {
                             temps=temps+1;
                             Serial.print(temps);Serial.print(";");Serial.print(temperature);Serial.print("; ");Serial.println(N);
                             s=0;
                             erreur=consigne-temperature; 
                    Somme_erreurs=Somme_erreurs+erreur;
                    Delta_erreur=erreur-erreur_precedente;
                    erreur_precedente=erreur;
                    
                    N=Gain*(erreur)+ki*Somme_erreurs+kd*Delta_erreur;
                       if (N>255) {N=255;}
                      
                       if (N<1) {N=0;}
                    analogWrite(3,N);
                             
                            }
                    
                       
                }
                
  }

  
