// avec afficheur 2 lignes
// La lecture se fait sur A1 et la sortie PWM sur D3 !!


// bilbiothèques liquidCrystal à télécharger 

#include <Wire.h>;
#include <LiquidCrystal_I2C.h>;
unsigned long millis();

unsigned long ecart;
unsigned long tempsms;
unsigned long lastTime;
float temps=0;
float commande;
float consigne;

float temperature,tension;
int mesure;
int N=255;
int Gain=50;
unsigned long int avgValue;  //Store the average value of the sensor feedback

int buf[20],temp;

//déclaration optionnelle de l'afficheur 2 lignes)
LiquidCrystal_I2C lcd(0x27, 16, 2);


// Boucle Setup pour indiquer le port de communication
void setup()   {
  Serial.begin(9600);
  commande=255;
  consigne=28,
  lcd.init(); // initialisation de l'afficheur
 analogReference(INTERNAL);
  
  pinMode(3,OUTPUT);
 
  delay(1000);
  //digitalWrite(3,commande);
 Serial.print("Temps(s) ");Serial.print(";");Serial.print("Température (°C)"); Serial.println("N (pwm)");
 
 //affichage optionnel sur afficheur
 lcd.backlight();
 lcd.setCursor(0, 0);
 lcd.print("Consigne :");
 lcd.setCursor(0,1);
 lcd.print("Temp :");

// Boucle principale
lastTime=millis();
}
void loop()
{ 



ecart=millis()-lastTime;
  if(ecart>1000){
                        
                        
                        
                        tempsms=(tempsms+ecart);

                        for(int i=0;i<20;i++)       //Acquisition de 20 valeurs
                        { 
                         buf[i]=analogRead(A1);
                          delay(10);
                         
                          
                         }
                       
                        for(int i=0;i<19;i++)        //tri du plus petit au plus grand
                         {
                         for(int j=i+1;j<19;j++)
                          {
                          if(buf[i]>buf[j])
                           {
                           temp=buf[i];
                            buf[i]=buf[j];
                          buf[j]=temp;
                          }
                          }
                          }
                        avgValue=0;
                        for(int i=6;i<14;i++) {                     //Moyenne des mesures
                         
                        
                         avgValue+=buf[i];}
                         
                         tension=(float)avgValue*1.1/1024/8; //calcul de la tension
                                          
                                              
                       
                        temperature=tension*100.0/2.0;      // Calcul de la température avec amplificateur par 2
                        
                     
                      temps=tempsms/1000;
                      
                      Serial.print(temps);Serial.print(";");Serial.print(temperature);Serial.print("; ");Serial.println(N);
                      lastTime=millis();  
                      
 // Affichage optionnel sur afficheur LCD
 
 lcd.setCursor(12, 0);
 lcd.print(consigne);
 lcd.setCursor(12,1);
 lcd.print(temperature);


                        
 //commande avec réglage proportionnel
                        
                       N=Gain*(consigne-temperature);
                       if (N>255) {N=255;}
                       analogWrite(3,N);
                       if (N<1) {N=0;}
                       analogWrite(3,N);
                      }
}
