
#include <Wire.h>;
#include <LiquidCrystal_I2C.h>;

int k=0;
unsigned long millis();
unsigned long ecart;
unsigned long tempsms=0;
unsigned long lastTime;

float temps=0;
double commande;
double consigne;

double temperature,tension;
int entree,entreeprec;
int N=255;
int Gain=50;
float mesure=0.00;

LiquidCrystal_I2C lcd(0x27, 16, 2);


void setup()   {
  Serial.begin(9600);
  commande=255;
  consigne=28,
  lcd.init(); // initialisation de l'afficheur
 analogReference(INTERNAL);
 
 pinMode(3,OUTPUT);
 
 Serial.print("Temps(s) ");Serial.print(";");Serial.print("Température (°C)"); Serial.println("N (pwm)");
 lcd.backlight();
 lcd.setCursor(0, 0);
 lcd.print("Consigne :");
 lcd.setCursor(0,1);
 lcd.print("Temp :");


lastTime=millis();
}

// Boucle principale

void loop()
{ 

ecart=millis()-lastTime;
  if(ecart>10){     k=k+1;
                    entree=analogRead(A0);
                    mesure= 0.993756*mesure+0.00624395*entree;
                    tempsms=(tempsms+ecart);
                    temps=tempsms/1000;
                    lastTime=millis();
                    tension=1.1*mesure/1024.0;
                    temperature=tension*100/2;
                    entreeprec=entree;
                    N=Gain*(consigne-temperature);
                       if (N>255) {N=255;}
                       analogWrite(3,N);
                       if (N<1) {N=0;}
                if (k==100){      
                  
                  Serial.print(temps);Serial.print(";");Serial.print(temperature);Serial.print("; ");Serial.println(N);
                     lcd.setCursor(12, 0);
                    lcd.print(consigne);
                   lcd.setCursor(12,1);
                   lcd.print(temperature);
                   k=0;
                            }
                          
               }
}
